<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Cours/TD - résumé1</TITLE>
<META NAME="GENERATOR" CONTENT="Arachnophilia 3.9">
<META NAME="FORMATTER" CONTENT="Arachnophilia 3.9">
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">

</HEAD>


<BODY BACKGROUND="../icons/reptile.jpg" BGCOLOR="#F0D0A0" TEXT="#000000" LINK="#0000ff" VLINK="#800080" ALINK="#ff0000">

<CENTER><H1>Cours/TD - résumé (1)</H1>
</CENTER>
<P>
<p>
<TABLE width=100%>
 <TR><TD align=right><A HREF="comres2.html">Page suivante :<IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>

<H3><FONT COLOR=#ff0000>12.10.99</FONT></H3>
<p>
<H2>Cours - le début</H2>
<p>
Nous avons traité :

<ul>
<li> Quelques questions administratives concernant les polycopiés, et les pages Web. Si vous lisez cette page, vous savez déjà comment y accéder.

Il y aura une nouvelle mouture des polycopiés, mais ne me demandez pas quand... Ceci dit, les notes Web seront assez complètes.

<li> J'ai mentionné les livres de <B>Andrew Appel</B>, et de <B>Aho-Sethi-Ullman</B> comme deux positions bibliographiques raisonnables. Mais vérifiez aussi les ressources Internet.

<li> Installation des outils de travail, comme Gentle, ou l'interprète de Haskell (Hugs 98). Je vous considère tous comme des utilisateurs de Linux sur notre réseau. Ma "niche" logicielle se trouve dans <tt>/usr/share/soft</tt>. Si vous voulez travailler chez vous, il suffit de me le dire, je vous fournirai tout le support disponible sous Windows également. 

<li> Votre devoir. Il est possible que je vous demanderai la construction d'un parseur/interprète d'un sous-ensemble du LaTeX - le macro-langage du système de formatage des textes, que vous serez encouragés d'apprendre de toute façon. <FONT COLOR=#0000A0>Alors, rien d'officiel, mais commencez dès et déjà.</FONT>

<li> Deux exemples simplistes de programmes en Haskell, car ce langage moderne sera notre outil principal de codage. Il s'agissait de mentionner quelques propriétés de ce langage:
<ul>
<li> C'est un langage fonctionnel pur, sans effets de bords, sans affectation ; les structures syntaxiques de base sont des expressions (entités qui possèdent une valeur), et non pas des instructions.
<li> On peut utiliser la syntaxe infixe, avec les opérateurs arithmétiques habituels, avec la structure conditionnelle standard <tt>if - then - else</tt>, et avec les variables locales (assignées une seule fois, c-à-d. initialisées). C'est un langage plus commode que les variantes de Lisp/Scheme (mais c'est une opinion personnelle...)
<li> C'est un <i>langage typé, avec l'inférence automatique de types</i>. De plus, le typage est polymorphe, avec une couche de programmation générique (classes de types) très puissante.
</ul>

L'apprentissage de Haskell est rapide et facile au début, mais c'est un langage complexe, et quelques détails tordus seront abordés plus tard. (On dit que la pente d'aprentissage est importante.)

<li> Je vous ai présenté mon programme prévisionnel, sans trop de détails (et sans garantie, car j'adore improviser...). Concrètement, j'envisage de structurer le cours de manière suivante :
<ul>
<li> Machines virtuelles (interprètes) et mécanismes d'évaluation. Compilation vue de la perspective de l'<i>évaluation partielle</i>
<li> Analyse ; la machinerie standard, lexicale et syntaxique. Actions sémantiques, attributs, compilation dirigée par la syntaxe, génération du code classique, et autres standards techno...
<li> Le <i>Runtime</i>. Gestion de mémoire dynamique, garbage collection, etc.
</ul>

<li> J'ai essayé de justifier mon choix du langage et la structuration du cours, mais il faut savoir que tous les cours de compilation sont différents. Je veux utiliser les mécanismes et les outils de très haut niveau, donc plutôt abstrait, mais effectivement programmables. Les langages fonctionnels et/ou logiques sont mes outils préférés. 
</ul>
<p>

<B>En maîtrise d'Informatique il est inutile de faire une introduction idéologique, qui définit un langage de programation ou le mot "compilation", et qui en donne des exemples - jouets. Tous les étudiants ont suivi le cours Langages/Automates, et chacun connaît un certain nombre de langages.
</B>
<p>

Donc, mon introduction (développée quand même - peut-être - dans le polycopié) se réduit à la constatation que 
<UL>
<LI> Ce cours est important, vu la prolifération des nouveaux langages presque tous les mois. Connaître les techniques d'implantation est devenu professionnellement indispensable.
<LI> Les langages formalisés constituent le moyen de communication homme-machine privilégié, on ne peut pas réduire tout à la clicquerie intéractive.

<LI> Cette communication fait partie de la couche d'interfaçage des gestionnaires des BD, paquetages graphiques, éditeurs de textes, logiciels du diagnostic des réseaux, etc., sans parler des navigateurs Web... Scripting, macros, - tout cela doit être implanté.

<LI> Donc, souvent ces logiciels sont équipés de petits interprètes - machines virtuelles qui ne génèrent aucun code binaire "natif", de bas niveau, mais un code intermédiaire, interprété.
<li> Un tel code est souvent portable, indépendant de la plate-forme, ce qui facilite le dépannage, la mise en ouvre des agents nomades, etc. La carrière de Java n'est pas le résultat du fait que ce soit un <i>langage</i> particulièrement commode... De plusieurs points de vue il et <i>pire</i> que C++. Mais il a été bien implanté !

<li> Les nouveaux langages exploitent les ressources machine de manière beaucoup plus automatique et dynamique que les "champions de vitesse" style "C". Threads, ramasse-miettes, etc. - tout ceci est extrêmement important pour l'économie du temps humain pendant la création de l'application, puisque augmente la modularité et clarté du programme.
</UL><p>
Bref, notre ambition est de faire un cours moderne et utile. Mais il ne sera ni super-universel, ni structuré de façon très disciplinée et formalisée. Ne cherchez pas la table des matières de ces notes. Mais j'envisage d'y ajouter un jour un hyper-index.

<p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>Quelques détails</H2>
<p>

<h3>Nos premiers exemples de programmes en Haskell</h3>
<p>
Voici la définition du sinus hyperbolique :
<pre>
sinh x =  let y=exp x     -- (commentaire) SIN HYP
          in (y-recip y)/2.0
</pre><p>
ou l'alternative :
<pre>
sinh x =  (y-recip y)/2.0  where y=exp x
</pre><p>
on note l'absence des mots clés comme "define", "function", etc. Les seuls ici ce sont <TT>where</TT> et <TT>let ... in</TT>. Si à gauche de l'opérateur "=" figure <i>un</i> identificateur, nous avons la définition et l'initialisation d'une variable ; sinon c'est une fonction, les identificateurs qui suivent le premier dénotent les paramètres. Mais en fait c'est la même chose, voici encore une autre variante :
<pre>
sinh =  \x -&gt; (y-recip y)/2.0  where y=exp x
</pre><p>
Le <I>backslash</I> symbolise la forme "lambda" du Lisp, qui construit des objets fonctionnels. <TT>recip x</TT> signifie naturellement <TT>1/x</TT>.<P>

La notoire forme <i>lambda</i> connue de tous les utilisateurs du Lisp ou Scheme, est un peu moins visible dans les programmes en Haskell, grâce à une autre invention syntaxique : les applications partielles. Si <TT>x/y</TT> signifie la division de x par y (quelle surprise, non?), alors la forme bizarre <TT>(x/)</TT>, où les parenthèses sont essentielles, est <i>exactement</i> la même forme que <TT>\y -&gt; x/y</TT>, et <TT>(/y)</TT> est naturellement équivalent à <TT>\x -&gt; x/y</TT>. La forme <TT>(/)</TT> est l'opérateur de division lui-même, mais avec les propriétés syntaxiques (précédence) neutralisées, on peut l'appeler comme une fonction normale : <TT>(/) x y</TT>.<p>
Par contre, tout symbole fonctionnel binaire, par exemple <TT>div</TT>, normalement appliqué comme une fonction : <TT>div x y</TT> peut être mis entre les apostrophes inversées, et jouer le rôle d'un opérateur infixe : <TT>x `div` y</TT>
<p>


L'inférence automatique de types (<B>très</B> simplifiée) est une déduction logique : si une expression est divisée par 2.0, elle est numérique, réelle. Donc, <TT>y</TT> est réel, et la fonction <TT>exp</TT> possède le type 
<TT>Float-&gt;Float</TT>. Le même type est attribué à <TT>sinh</TT>.
<p>

Mais les paramètres d'une fonction peuvent être également des fonctions. Notre second exemple :
<pre>
f x = x 2.0
</pre><p>
est analysé comme suit :  Si <TT>f</TT> applique <TT>x</TT> à 2.0, le type de <TT>x</TT> est <TT>Float-&gt;a</TT>, où <TT>a</TT> est une "variable type", inconnue. <TT>x</TT> est donc une fonction <I>polymorphe</I>. Son appel retourne le résultat de <TT>f</TT>, donc cette dernière aura le type:
<TT>(Float-&gt;a)-&gt;a</TT>. Pourquoi est-il utile d'apprendre cela? Parce qu'il faut comprendre les messages diagnostiques, et plus de moitié de fautes sémantiques dans votre programme ce seront les erreurs de typage ! Et nous aurons besoin de fonctions d'ordre supérieur et polymorphes très souvent.
<p>

<p><hr><p>

Ensuite nous avons traité les sujets suivants. Vous trouverez ici le résumé, l'"idéologie". Presque tout sera répété prochaînement, avec les diagrammes et détails du codage.
<p>

<h3>Machines virtuelles ; mécanismes d'évaluation</h3><p>
L'idée <EM>essentielle</EM> de notre philosophie est : de point de vue d'implantation, <i>un programme est une structure de données</i>. Son évaluateur, la machine virtuelle qui l'exécute est naturellement un programme, donc il faut bien distinguer entre les concepts pertinents au langage compilé, et les méta-concepts. Si on utilise un langage évolué pour décrire un compilateur, les pièges son nombreux (par exemple on définit/réalise la récursivité par un mécanisme récursif...)
<p>

Nous avons commencé par l'évaluation d'une expression algébrique, p. ex.
<TT>a+2*(b-x-3/a)</TT>, ce qui sur le plan syntaxique (précédences des opérateurs) dénote 
l'arborescence
<PRE>
       +
      / \
     a   *
        / \
       2   -
          /  \
         /    \
        -     div
       / \    /  \
      b   x  3    a
</PRE><p>
Si on peut attribuer des valeurs à des feuilles de cet arbre : les constantes et les variables, et si on définit la sémantique primitive des opérations, c'est-à-dire si le programme "sait" ce que signifie "<TT>+</TT>", etc., le reste est établi par une simple procédure de parcours "post-order" - on évalue récursivement les branches, et on applique l'opérateur.<p>

Naturellement, ceci est très inefficace, même si un petit interprète peut utiliser cette stratégie, grâce à sa simplicité de codage. Nous verrons qu'un tel arbre peut constituer une structure intermédiaire lors de la compilation du programme.
<p>

La technique <EM>standard</EM> de linéariser les expressions consiste à créer le code postfixe, interprété par une machine à pile. Notre expression se transformera en
<PRE>
a 2 b x - 3 a / - * +
</PRE><P>

et la machine qui évalue de telles expression marche comme une boucle qui parcourt le "programme" (code postfixe), et exécute :
<UL>
<LI> Si l'item du programme est une donnée, elle est empilée, sinon
<LI> c'est un opérateur qui consomme un certain nombre d'éléments de la pile, s'applique, et empile le résultat.
<LI> À la fin la pile doit contenir un seul élément - le résultat final.
</UL><p>
Le code postfixe <EM>est la base</EM> de presque tous les codes de bas niveaux, et c'est le code le plus primitif et portable en même temps. Les optimisations ultérieures, comme l'usage des registres matériels dépendent de l'architecture de la machine physique. <p>

Mais l'observation essentielle qui s'impose à présent est la suivante : On ne jète pas à la poubelle notre interprète récursif ! À l'envers, il est maintenant le noyau de notre <i>compilateur</i>. Seulement au lieu d'évaluer les expressions, il les traduit en code postfixe : La feuille va telle quelle ; un noeud intermédiaire est traité récursivement - las branches sont compilées, transformées en séquences linéaires, et ensuite concaténées, avec l'opérateur à la fin. Notez que la génération du code postfixe est une sorte d'évaluation, on peut l'appeler <i>l'évaluation partielle</i>. L'application de l'opérateur, est la concaténation des morceaux de code.

<a name="environ">
<h3>Environnements</h3></a>
<p>
Mais comment évaluer les feuilles, ou, plus généralement, comment distinguer un opérateur d'une constante ou d'une variable? La machine doit opérer sur une <EM>structure associative</EM>, l'<EM>environnement</EM>, qui établit les relations entre les symboles et les valeurs/attributs. on peut imaginer que ceci est une liste de genre <TT>[(x,6.2), ("+",ADD), ...]</TT> etc., mais les détails à régler sont nombreux :
<UL>
<LI> L'environnement ne peut être statique si on utilise des procédures en réutilisant les noms. La possibilité des appels récursifs force sa structuration en pile.
<LI> La "signification" d'un symbole n'est pas toujours fixée. L'opérateur d'addition peut avoir plusieurs instances différentes, selon le type des arguments.
<LI> La "même chose" parfois ne l'est pas vraiment. Dans un langage impératif l'affectation <TT>x:=x+1</TT> force l'évaluation du x à droite, mais la valeur de x à gauche n'a pas d'importance, il faut seulement résoudre son <EM>adresse</EM> pour y placer une nouvelle valeur.
</UL><p>


<h3>Qu'est-ce qu'une structure de contrôle</h3><p>
Une expression conditionnelle, par exemple <TT>if x&gt;0 then 2*x else 5</TT> dont l'arbre syntaxique peut être dessiné comme
<PRE>
        if
       / | \
      /  |  \
     &gt   *   5
    /|   |\
   x 0   2 x   
</PRE><p>
a l'apparence d'une expression comme les autres, mais son mécanisme d'évaluation est très différent. L'évaluateur n'a pas le droit d'évaluer <i>toutes</i> les branches avant d'en choisir une parmi les clauses then/else. Seulement la condition est évaluée inconditionnellement, ensuite <tt>if</tt>, sa sémantique spécifique force l'évaluation d'une seule branche parmi les restantes.<p>

On appelle un tel protocole <EM>l'évaluation paresseuse</EM>. En général, si en C, Pascal, Lisp, etc. on appelle la fonction f avec un argument qui déclenche une exception, par exemple <TT>f(1/0)</TT>, l'argument est évalué avant le transfert du contrôle à <TT>f</TT>, et celle-là ne sera jamais exécutée si l'évaluation de l'argument "bombe". On dit que le protocole d'évaluation dans ces langages est <EM>strict</EM>.<p>

Mais dans le protocole paresseux (non-strict) la fonction <TT>f</TT> commence son exécution. Si dans un contexte précis elle n'a pas besoin d'un argument, d'une valeur locale, etc., l'expression en question <i>ne sera jamais évaluée</i>, elle restera dans le programme comme une sorte de procédure anonyme sans paramètres (le <i>thunk</i>) qui n'est pas appelée. On dit parfois aussi que la fonction utilise le protocole <i>call by need</i>. On peut essayer de dire donc qu'<EM>une structure de contrôle est une fonction paresseuse</EM> où la paresse joue un role fondamental. Dans Haskell toutes les procédures sont paresseuses, mais pour la plupart ceci n'a aucune signification sémantique, et nous pouvons souvent oublier cette propriété. Ici elle est très importante, et nous permettra de traiter les structures de contrôle d'un niveau assez haut.
<p>



<h3>Comment une bête électronique sans aucune conscience peut prendre des décisions</h3><p>

<em>Où : comment réaliser la conditionnelle <TT>if - then - else </TT>  par des mécanismes primitifs.</em>
<p>

La discussion ci-dessus ne répond guère à la question principale : comment implanter <TT>if</TT>. Si on accepte la vision non-stricte de l'évaluation, la "pseudo-fonction if" prend la décision d'évaluation d'une branche en fonction de la condition, et ceci signifie que <i>son</i> implantation est équipé avec le mécanisme conditionnel. En descendant, il faut poser la question comment une instruction de saut (branchement) conditionnel en assembleur peut être implantée? Comment le silicium peut prendre une décision? Laissons à part les questions philosophiques, le problème est pragmatique. <UL>
<LI> Sur le plan matériel le résultat d'évaluation de la condition (le bit stocké dans un registre) est transformé en signal, en voltage, et à travers un circuit électronique ouvre ou ferme un chemin de données.
<LI> Dans un programme nous pouvons imaginer que les deus thunks alternatifs occupent deux cellules adjacentes. Le bit Booléen est ajouté à l'adresse plus petite (branche <tt>False</tt>), et s'il vaut 1, on récupère l'adresse de la branche <tt>True</tt>. Le reste est inconditionnel.
</UL><p>

Le but de cet exemple est double : souligner l'importance de la distinction entre les niveaux d'implantation, et suggérer en même temps que les structures de contrôle de très bas niveau perdent immédiatemment tout contact avec le système de types. On est obligé par exemple d'établir une arithmétique de pointeurs.


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>

<p>
<H2>TD</H2>
<p>
<i>Si vous trouverez ici les sujets qui n'ont pas été vraiment abordés, ceci peut être le résultat d'un petit écart entre les programmes réalisés dans les deux groupes. Je le regrette, mais parfois cela arrivera.</i>
<p>

Nous avons codé quelques algorithmes classiques sur les listes, pour nous familiariser avec la programmation en Haskell, à sa syntaxe, et son style.<P>

<H3>Concaténation</H3><p>
Les listes en Haskell utilisent la syntaxe <TT>[a,b,c,d,e]</TT>, et l'opérateur "cons" qui ajoute la tête à la queue est l'opérateur infixe <TT>"(:)"</TT> (sans parenthèses, tout simplement deux points, mais un opérateur entre parenthèses peut être considéré comme un symbole fonctionnel, comme il a été déjà expliqué). Donc <TT>a : [b,c] == [a,b,c]</TT>. Les listes en Haskell sont <B>typées</B>, tous les éléments appartiennent à la même ethnie. Voici le code de la procédure récursive de concaténation des listes. C'est parfaitement classique, comme en Scheme/Lisp, seulement la syntaxe est nouvelle :
<pre>
l1 ++ l2 = 
 if l1==[] then l2 else  hd l1 : (tl l1 ++ l2)
</pre><p>
<H4>Remarques</H4>
<UL>
<LI> Si vous ne comprenez pas cette définition, il vous faudra reviser le matériel de 2 dernières années, la gestion des listes en Lisp ou en Scheme, etc. C'est <B>absolument</B> indispensable.
<LI> La précédence de l'application fonctionnelle est plus grande que celle des opérateurs infixes (qui peut varier selon l'opérateur). 
<LI> L'indentation normalement signifie que la ligne suivante fait partie de la structure syntaxique de la ligne précédente. L'indentation négative signale la fin de la structure, l'indentation zéro signifie le début d'une structure colatérale (si possible).
<LI> N'oubliez pas que dans un langage fonctionnel il n'y a pas d'instructions, seulement les expressions. Donc, la conditionnelle <TT>if - then - else</TT> doit être complète.
</UL><p>

Normalement, si la conditionnelle dans une fonction sert uniquement à distinguer entre les cas structuraux concernant les paramètres, ici : la discrimination entre la liste vide et non vide, on évite l'usage de <TT>if</TT> grâce au <em>passage de paramètres par pattern</em>. Comparez la définition ci-dessus avec celle-là :
<PRE>
[] ++ l2 = l2
(h1:t1) ++ l2 = h1 : (t1 ++ l2)
</PRE><p>
<EM>Si la paramètre d'une définition fonctionnelle est une expression, constante ou composite, et non une variable (identificateur), alors c'est un <i>pattern</i> (motif), qui est automatiquement destructuré</EM>. Ainsi on n'a pas besoin de séparer "manuellement" la tête de la queue de la liste - le protocole d'appel par pattern s'en charge.<p>

Voici deux réalisations du code qui renverse une liste. La première variante est la classique solution récursive "en profondeur" qui doit être évitée :
<PRE>
reverse [] = []
reverse (x:q) = reverse q  ++ [x]
</PRE><p>
et la solution optimisée, qui utilise un tampon :
<PRE>
reverse l = revaux l []   where
  revaux [] tmp = tmp
  revaux (x:q) tmp = revaux q (x:tmp)
</PRE><p>
<b>Vous devez apprendre construire des définitions de ce genre sans hésitation.</b>
<TT>revaux</TT> est une fonction auxiliaire, locale.
<p>

<H3>Tri par insertion</H3><p>

Voici le code du <i>tri par insertion</i>. La stratégie consiste à répéter l'insertion de chaque élément de la liste-source dans le résultat considéré toujours ordonné. L'insertion parcourt la liste tampon/résultat, et place l'élément là, où la relation d'ordre l'exige. Cette fois la décision à prendre dépend de la relation d'ordre entre deux objets, et non pas de la structure du paramètre. Utilisons de nouveau la	conditionnelle <TT>if</TT>. Présentons encore une fois deux solutions : récursive générale, et optimisée par la récursivité terminale.
<PRE>
instri [] = []
instri (x:q) = insere x (instri q)

insere x [] = [x]
insere x (y:q) = if x&lt;=y then x:y:q else y:insere x q
</PRE><p>
On voit ici une légère inefficacité : la liste - argument de <TT>insere</TT> est déstructuré grâce à l'appel par pattern, et ensuite la tête et la queue sont restructurés de nouveau. Il serait judicieux de pouvoir en même temps destructurer le paramètre, mais garder l'accès à la totalité, à son nom. Voici le dispositif syntaxique en Haskell qui le permet :
<PRE>
insere x [] = [x]
insere x l@(y:q) = if x&lt;=y then x:l else y:insere x q
</PRE><p>
Et voici la solution itérative :
<PRE>
instri l = itaux l [] where
  itaux [] tmp = tmp
  itaux (x:q) tmp = itaux q (insere x tmp)
</PRE><p>
L'insertion ne change pas. Mais nous pouvons changer sa <i>forme</i>, et encore une fois éliminer l'usage de la conditionnelle. Il faut maîtriser la syntaxe suivante, avec les alternatives identifiées par la barre verticale :
<PRE>
insere x [] = [x]
insere x l@(y:q) | x&lt;=y      =   x:l
                 | otherwise =   y : insere x q
</PRE><p>
Ici l'identificateur <TT>otherwise</TT> n'est pas un mot-clé, mais une variable dont la valeur est <TT>True</TT>. La syntaxe des clauses conditionnelles est simple : le signe "=" de la définition est remplacé par une suite de clauses :<TT>| condition = expression</TT>, et qui est évalué séquentiellement de haut vers le bas, en cherchant la première condition satisfaite (comme le <TT>COND</TT> en Lisp).
<p>
<H3>Tri rapide</H3><p>

Construisons - encore une fois, pour l'entraînement - un procédure de tri plus efficace, le <i>quicksort</i> : le tri rapide de C.A.R. Hoare, pour les listes. L'algorithme consiste à partitionner la liste-source en deux sous-listes : les éléments inférieurs, et séparemment les éléments supérieurs à un élément choisi arbitrairement - le pivot ; normalement c'est la tête de la liste. Par exemple, la liste <TT>[5,8,3,1,9,6,4,7,10,2]</TT> sera partitionnée en <TT>[3,1,4,2]</TT>, et <tt>[8,9,7,10]</tt>. Ensuite on applique récursivement le tri aux sous-listes, et on concatène le résultat avec le pivot intercalé entre les deux. Construisons d'abord la fonction de partition. Elle doit retourner <i>deux</i> valeurs, les deux sous-listes. Nous pourrions mettre ces valeurs dans une liste de deux éléments, mais en Haskell la solution plus simple, naturelle et efficace, serait d'utiliser les <i>tuples</i>. Ici il s'agit d'une paire ou d'un doublet dénoté par <TT>(a,b)</TT>, où les éléments peuvent appartenir à de types quelconques. Les tuples <TT>(x,y,z)</TT>, <tt>(a,b,c,d,e)</tt>, etc. peuvent être hétèrogènes, et leur notation sert de constructeur ainsi que de pattern pour la destructuration automatique. Voici le code, qui utilise deux tampons auxiliaires pour rendre la procédure plus efficace.
<PRE>
-- APPEL: partit pivot liste tmpPetits tmpGrands
partit _ [] tp tg = (tp,tg)
partit p (x:q) tp tg | x&lt;p = partit p q (x:tp) tg
                     | otherwise=partit p q tp (x:tg)
</PRE><p>
où le <i>underscore</i> "<TT>_</TT>" symbolise une variable anonyme qui n'est pas utilisée. Voici le code du quicksort :
<PRE>
quicksort [] = []
quicksort (x:q) = let (a,b)=partition x q [] []
                  in  (quicksort a)++(x : quicksort b)
</PRE><p>
Nous avons laissé cette procédure sous cette forme, cependant il existe une technique d'optimisation universelle et importante qui dans quelques cas élimine la concaténation des procédures récursives. Ceci peut être utile, car la concatétation qui génère les résultats intermédiaires produit des copies des copies des copies ... ce qui encombre la mémoire avec les miettes. Définissons une procédure généralisée, qui prend deux arguments, trie le premier, et concatène le résultat avec le second. Formellement :
<PRE>
-- qsort l t = quicksort l ++ t
</PRE><p>
Mais ceci est une "pseudo-définition", notre but est justement contraire, de définir <TT>quicksort</TT> à l'aide du <TT>qsort</TT>.
<PRE>
quicksort l = qsort l [] where
 qsort [] t = t
 qsort (x:q) t = let (a,b) = partition x q [] []
                 in  qsort a (x : qsort b t)
</PRE><p>
Cool, non? Nous en aurons encore besoin.
<p>
<h3>Construction des arbres binaires, recherche</h3><p>
Encore un autre algorithme de tri (pour nous ce n'est qu'un prétexte...) est basé sur les arbres binaires, dont les noeuds stockent les valeurs comparées. Pour ajouter un élément dans un arbre il faut descendre au niveau des feuilles et accrocher le nouveau élément en bas. On suit la branche gauche si l'élément inséré est plus petit que la valeur de la racine. Ainsi, la génération itérative d'un arbre binaire à partir de la liste <TT>[5,8,3,1,9,6,4,7,10,2]</TT> produira
<PRE>
        5
       / \
      /   \
     3     8
    / \   / \
   1   4 6   9
    \     \   \
     2     7  10
</PRE><p>
Le tri n'est rien d'autre que l'aplâtissement récursif (in-order) de cet arbre. Mais nous voulons traiter ici sa représentation. Nous pourrions utiliser les tuples, le triplet <TT>(brGauche,valRacine,brDroite)</TT> (ou dans un ordre différent), mais pour varier, définissons une nouvelle structure de données, un <i>record</i> balisé. Quel est le type de ses éléments? Laissons cette question ouverte à l'aide d'un paramétrage, et définissons un arbre de quoi que ce soit :
<PRE>
data Arbre a = Nil | T a (Arbre a) (Arbre a)
</PRE><p>
ici <TT>Nil</TT> dénote l'arbre vide, et <TT>T</TT> est la balise (tag) qui joue le rôle du constructeur, et du discriminateur de pattern si on passe de telles structures comme arguments. <TT>a</TT> est une "variable type", un type inconnu. Ainsi <TT>Arbre</TT> est une structure <EM>polymorphe</EM>, nous pouvons avoir dans le programme plusieurs arbres de différents espèces, mais qui peuvent partager quelques fonctions de parcours qui ne regardent pas le type des valeurs. Le nom <i>a</i> ou autre n'a aucune signification. Il faut seulement savoir que les variables - valeurs ou types, ont des noms qui commencent par minuscules, et par majuscules commencent les noms qui définissent les constructeurs et autres balises. Ce sont des <i>constantes</i> symboliques.<p>

Voici la fonction qui transforme une liste en arbre, en commençant l'insertion par un tampon vide.
<PRE>
arbconstr l = arb l Nil where
 arb [] a = a
 arb (x:q) a = arb q (ain x a)

 ain x Nil = T x Nil Nil
 ain x a@(T y p g) | x&lt;y=T y (ain x p) g
                   | x&gt;y=T y p (ain x g)
                   | otherwise=a   -- pas de doublons!
</PRE><p>
Naturellement la manière de gérer les doublons est une question de choix.<p>

L'arbre dessiné ci-dessus est composé des entiers. Mais nous pouvons faire des arbres avec d'autres types d'éléments également. Mais pas avec n'importe-quoi ! La procédure <TT>arbconstr</TT> ne marchera que si les expressions concernées admettent la relation d'ordre <TT>&lt;</TT> (et son inverse). Si nous voulons faire un arbre à partir des objets composites, p. ex. des paires <TT>(clé,valeur)</TT>, il faut ou bien compliquer la construction :
<PRE>
 ain x Nil = T x Nil Nil
 ain x@(xc,xv) a@(T y@(yc,yv) p g) | xc&lt;yc=T y (ain x p) g
                   | xc&gt;yc=T y p (ain x g)
                   | otherwise=a
</PRE><p>
ou, éventuellement, définir la relation d'ordre pour les paires de ce genre, par exemple
<PRE>
(a,_) &lt; (b,_) = a &lt; b
</PRE><p>
mais ceci est un peu plus compliqué que ça, nous y reviendrons plus tard. La recherche qui à partir d'une clé retourne la valeur correspondante ne présente aucune difficulté, sauf une : que fait-on en cas d'échec? Pour l'instant on propose la solution suivante :
<PRE>
cherche xc Nil = error "Mais quelle tragédie"
cherche xc (T (yc,yv) p g) | xc==yc = yv
                           | xc&lt;yc = cherche xc p
                           | otherwise = cherche xc g
</PRE><p>
On a proposé : retourner <TT>Nil</TT> en cas d'échec. Non, c'est faux, erreur de typage ! La fonction <TT>error</TT> est une fonction polymorphe qui "s'adapte" à n'importe quel type de réponse, sauf qu'elle ne fournit aucune réponse, mais déclenche une exception "panique".

<p>
<h3>Exercice</h3><p> 
<EM>(moralement obligatoire !)</EM> Coder l'algorithme de tri qui utilise les arbres binaires, c'est-à-dire la procédure d'aplâtissement des arbres. Ceci doit vous prendre 5 minutes.

<h3>Programmation paresseuse; listes cycliques, flots infinis</h3><p>

Analysons le programme (complet) suivant :
<PRE>
uns = 1 : uns
</PRE><p>
Ceci est une abomination, une définition récursive sans clause terminale, qui risque d'exploser la mémoire. En Haskell cela marche sans déclencher des erreurs. En effet, c'est une liste infinie [1,1,1,...], mais réalisée comme une liste cyclique. Sa tête pointe sur le nombre 1, et sa queue - sur elle même. Si on consomme la liste de manière incrémentale, on peut travailler longtemps. Mais ceci :
<PRE>
integs n = n : integs (n+1)

nats = integs 1
</PRE><p>
est plus délicat. La procédure <TT>integs</TT> est acceptée sans problème. Ce n'est pas la définition qui fait des dégats, mais l'appel. L'appel qui construit <TT>nats</TT> génère [1,2,3,4,...], et en C, Lisp, Fortran, Pascal, etc. le résultat est le débordement immédiat de mémoire. <p>

Haskell est un langage paresseux, et <TT>(:)</TT> est un <EM>opérateur paresseux</EM>. Si on créé une liste <TT>(x:q)</TT>, mais si on ne regarde jamais la valeur du second élément, il peut être caché dans un thunk pour longtemps. Ici l'exécution du premier appel créé la liste <TT>(1 : integs 2)</TT>, mais <TT>integs 2</tt> <i>n'est pas appelé</i>. Ce "démon" reste caché et inerte jusqu'au moment ou l'utilisateur demande l'instanciation de la queue de <TT>nats</TT>. Alors <TT>integs 2</TT> génère <TT>(2 : integs 3)</TT>, et s'arrête. <p>

Ainsi le langage nous permet de générer et de consommer incrémentalement des flots de données très longs, par exemple des fichiers de plusieurs giga-octets transformés en listes paresseuses de caractères (chaînes). Il vous faudra vivre avec ça jusqu'à la fin de ce cours, vous en verrez encore plusieurs dizaines d'exemples. La technique de transduction des flots remplace les techniques itératives avec des boucles, typiques pour la programmation impérative.




<p>
<TABLE width=100%>
 <TR><TD align=right><A HREF="comres2.html">Page suivante :<IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>



</BODY>

</HTML>
